//
//  HelloWorldLayer.h
//  FrameworkB
//
//  Created by James Gamble on 30/09/2012.
//  Copyright James Gamble 2012. All rights reserved.
//


#import <GameKit/GameKit.h>
#import "GameCenterManager.h"


// When you import this file, you import all the cocos2d classes
#import "cocos2d.h"

@class GameCenterManager;

// HelloWorldLayer
@interface HelloWorldLayer : CCLayer <GKAchievementViewControllerDelegate, GKLeaderboardViewControllerDelegate, GameCenterManagerDelegate>
{
    
    
    // GameCenter Stuffs
    GameCenterManager* gameCenterManager;
    
    IBOutlet UIView* resetAchievementsView;
    IBOutlet UIButton* achievementButton;
    
    NSString* personalBestScoreDescription;
    NSString* personalBestScoreString;
    
    NSString* leaderboardHighScoreDescription;
    NSString* leaderboardHighScoreString;
    
    NSString* currentLeaderBoard;
    
    int64_t  currentScore;
    NSString* cachedHighestScore;
    
	// End GameCenter
    
}

//GameCenter

@property (nonatomic, retain) GameCenterManager *gameCenterManager;

@property (nonatomic, assign) int64_t currentScore;
@property (nonatomic, retain) NSString* cachedHighestScore;


@property (nonatomic, retain) UIView* resetAchievementsView;
@property (nonatomic, retain) UIView* gameButtonView;

@property (nonatomic, retain) NSString* personalBestScoreDescription;
@property (nonatomic, retain) NSString* personalBestScoreString;
@property (nonatomic, retain) NSString* leaderboardHighScoreDescription;
@property (nonatomic, retain) NSString* leaderboardHighScoreString;
@property (nonatomic, retain) NSString* currentLeaderBoard;

- (IBAction) resetAchievements: (id) sender;

//- (void) addOne;
// - (void) submitHighScore;
//- (void) showLeaderboard;
//- (void) showAchievements;

//End GameCenter

// returns a CCScene that contains the HelloWorldLayer as the only child
+(CCScene *) scene;

@end
