//
//  HelloWorldLayer.m
//  FrameworkB
//
//  Created by James Gamble on 30/09/2012.
//  Copyright James Gamble 2012. All rights reserved.
//


// Import the interfaces
#import "HelloWorldLayer.h"

#import "SimpleAudioEngine.h"


// Needed to obtain the Navigation Controller
#import "AppDelegate.h"

#pragma mark - HelloWorldLayer

// HelloWorldLayer implementation
@implementation HelloWorldLayer


int GCAllow=0;
int MouseEnabled=0;

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  GameCenter
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

char* BoardLabel="com.agameaweek.MyGame_Board";  // in GameCenter, use "com.mydomain.MyGame_01/25"
char* AchieveLabel="com.agameaweek.MyGame_Badge";  // in GameCenter, use "com.mydomain.MyGame_01/100"
int Top10[1000];
char TopNam[1000][32];

int IsGC=0;
int BadgeSent[150];
int BadgeEarned[150];

int BoardUse=1;
int BoardRequested=0;
int CenterTesting=0;

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Main Menu
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

int EndofGame;

int MenuPop,ListShow;
int MenuSelect;
float menuR,menuG,menuB;
float menuAimR,menuAimG,menuAimB;
float menuRot,menuAimRot;
float mscroll;
float MenuIn,MenuIn2,MenuIn3,MenuIn4;

int modes[10];
char modeName[100][32];
int ThisGame;

float Part[2000];
int Partto;

int scfl[250];
int scflto;
int Delay;



// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Basic Settings for Engine
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

// Checksum - Safety in Numbers
#define ChecksumA 1234
#define ChecksumB 567
#define ChecksumC 89
#define ChecksumD 1011
// I'm not sure how specific Apple's rules on Encryption are, but they seem to allow Checksums!
// As long as your actual data isn't encrypted (ie, you can see it just fine) these little checksums seem to pass by without a hitch.
//  *fingers crossed*

//   You probably want to change these numbers.  Your online scores will depend on people not figuring them out.





#define MostImages 50        // max number of different images loaded in at once.

#define MaxSprites 40       // number of DrawImg's onscreen at once.

#define MostBatches 6        // Most batches the game can do.
#define MaxBatch 75         // Most images within each batch.

#define MaxText 15          // Most text batches onscreen at once.

// These default settings are alright!
// If you're using BIG images, scale the default values down a bit.
// If you want more LITTLE images, you can bang the numbers up a bit.
// For general purpose stuff, defaults are fine.

// Additional note about FramesPerSecond.

// I've set the PerFrame loop, and the Animation to be 45fps.
// This seems an odd number, but it's a nice midpoint.

// It LOOKS like it's going nice and fast, so most people will happily assume it's 60fps, and be none the wiser... (See SpikeDislike)
// Even if your game gets super busy, you won't actually SEE a framerate drop.
// It's only once it gets below 45fps that a little stuttering starts.
// Neato!

// If you'd rather your game is at 30 or 60 fps, do the following two steps.

// 1. Right at the bottom of the -(void) init function, (bottom of this file, then up a tiny bit) you'll find the first bit.
// [self schedule:@selector(perFrame) interval:(1.0f / 45.0f)];  <-- Change that to whatever your new fps is.

// 2. In AppDelegate.m, hunt for ...
// [director setAnimationInterval:1.0/45]; <-- Change that, too.

// I'm actually not 100% sure what the animation interval does, and am probably right in saying it's for pre-made anim things..
// but it doesn't hurt to be sure!



// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Your Variables start here.
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

int ang;
int m;
float scrx;
int World;

float StarX[MaxBatch];
float StarY[MaxBatch];
float StarXS[MaxBatch];
float StarR[MaxBatch];

int DrawWith;

float HoldX;
float HoldY;
float AimX;
float AimY;
float Spd;

int Grid[250];



// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Internal number stuffs
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

NSMutableArray *imgs;
NSMutableArray *objs;
NSMutableArray *objBatch;
NSMutableArray *sfx;
NSMutableArray *fonts;

NSMutableArray *Top10Data;
NSMutableArray *Top10IDs;


int High[1000];
// 5 Top scores + Last 5 scores, for 25 different gameplay types?


int mx[15],my[15],md[15],mudown[15],mdAll,mudownAll;
float AccelX,AccelY;
int OrientationUse,OrientationIs;
int touchCount;

int Paused;
float PauseDark;
int PauseTicks;

int imgw[MostImages],imgh[MostImages],imgx[MostImages],imgy[MostImages],imga[MostImages];
int Loader=0;

int Set[40];

int LastSprite=MaxSprites;
int TopSprite=0;

int LastBatch[MostBatches];
int TopBatch[MostBatches];
int BatchIs[MostBatches];
int ChangeBatch=-1;
int ChangeBatchTo[MostBatches];
int ChangeBatchZ[MostBatches];


int LastText=20;
int TopText=0;

float ScaleUp=1;
int MaxSize=8;
int scaleTo,isPad,isHD;
int J_Col_R,J_Col_G,J_Col_B;
int J_Alpha;
int J_BlendA,J_BlendB;
int jscrw,jscrh,jscrh2;
float J_Rot,J_ScaleX,J_ScaleY;

int GameMode,GameType,GameLevel,GameOpt;
int Level,Score;
int MenuPick;


// Image Loading Flags
#define Plain 0
#define NoAlpha 1
#define OnlyAlpha 2
#define LowRGB 4



// Helper class method that creates a Scene with the HelloWorldLayer as the only child.
+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	HelloWorldLayer *layer = [HelloWorldLayer node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}




// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Touchy
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Touch Stuff


- (void)ccTouchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    NSSet *allTouches = [event allTouches];  // <--this gets all the current touches
    touchCount=0;
    UITouch *firsttouch = [[allTouches allObjects] objectAtIndex:0];
    for (int n=0;n<15;n++) {md[n]=0;}
	for (UITouch *touch in allTouches) { //iterate through all the touches
        if (touchCount<10){
            //code here
            CGPoint location = [touch locationInView: [firsttouch view]];
            mx[touchCount+1]=location.x/scaleTo;
            my[touchCount+1]=location.y/scaleTo;
            md[touchCount+1]=1;
            touchCount++;
        }
	}
}


- (void)ccTouchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {
    NSSet *allTouches = [event allTouches];  // <--this gets all the current touches
    touchCount=0;
    UITouch *firsttouch = [[allTouches allObjects] objectAtIndex:0];
    for (int n=0;n<15;n++) {md[n]=0;}
	for (UITouch *touch in allTouches) { //iterate through all the touches
        if (touchCount<10){
            //code here
            CGPoint location = [touch locationInView: [firsttouch view]];
            //        location = [[CCDirector sharedDirector] convertToGL: location];
            mx[touchCount+1]=location.x/scaleTo;
            my[touchCount+1]=location.y/scaleTo;
            md[touchCount+1]=1;
            touchCount++;
        }
	}
}


- (void)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
    
    NSSet *allTouches = [event allTouches];  // <--this gets all the current touches
    touchCount=0;
    UITouch *firsttouch = [[allTouches allObjects] objectAtIndex:0];
    for (int n=0;n<15;n++) {md[n]=0;}
	for (UITouch *touch in allTouches) { //iterate through all the touches
        if (touchCount<10){
            CGPoint location = [touch locationInView: [firsttouch view]];
            mx[touchCount+1]=location.x/scaleTo;
            my[touchCount+1]=location.y/scaleTo;
            md[touchCount+1]=1;
            for (UITouch *touchb in touches) {
                if (touchb==touch) {md[touchCount+1]=0;}
            }
            touchCount++;
        }
	}
}

#define kFilterFactor 0.05
- (void)accelerometer:(UIAccelerometer*)accelerometer didAccelerate:(UIAcceleration*)acceleration{
    OrientationIs=[[UIDevice currentDevice] orientation];
    
    // Comment/Uncomment the following to allow for different orientations.
    
    
    // Landscape - Button on Right
    if (OrientationIs==3) {OrientationUse=3;}
    if (OrientationUse==3) {
        AccelX = acceleration.y;
        AccelY = acceleration.x;
    }
    // Landscape - Button on Left
    if (OrientationIs==4) {OrientationUse=4;}
    if (OrientationUse==4) {
        AccelX = -acceleration.y;
        AccelY = -acceleration.x;
    }
    
    /*
     // Portrait
     if (OrientationIs==1) {OrientationUse=1;}
     if (OrientationUse==1) {
     AccelX = acceleration.x;
     AccelY = acceleration.y;
     }
     // Portrait - Upside Down
     if (OrientationIs==2) {OrientationUse=2;}
     if (OrientationUse==2) {
     AccelX = -acceleration.x;
     AccelY = -acceleration.y;
     }
     */
    
}


// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - GameCenter
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=




- (void)GC_ReportScore:(int)score toBoard:(int)board {  // Just tell Gamecenter my score!!!!
    if (IsGC==1) {
        NSLog(@"Sending %d %s_%02d",board,BoardLabel,(board+1));
        [self.gameCenterManager reportScore: score forCategory: [NSString stringWithFormat:@"%s_%02d",BoardLabel,(board+1)]];
    }
}

- (void)GC_GetTop10:(int)board {  // Just fucking well put the top 10 highscores into a fucking array, ffs...
    if (IsGC==1) {
        BoardRequested=board;
        NSString *tstr=[Top10Data objectAtIndex:(BoardRequested*20)+1];
        
        if (tstr.intValue<1) {
            
            if (board<20) {
                [self.gameCenterManager reloadHighScoresForCategory:[NSString stringWithFormat:@"%s_%02d",BoardLabel,board+1] forPlayers:0];
                NSLog(@"requesting %d (%s_%02d)",board,BoardLabel,board+1);
            }
            if (board>19) {
                [self.gameCenterManager reloadHighScoresForCategory:[NSString stringWithFormat:@"%s_%02d",BoardLabel,board-19] forPlayers:1];
                NSLog(@"requesting %d (%s_%02d)",board,BoardLabel,board-19);
            }
        }
        if (tstr.intValue>0) {
            NSLog(@"skipping %d (%d)",board,tstr.intValue);
            [Top10Data replaceObjectAtIndex:(BoardRequested*20)+1 withObject:[NSString stringWithFormat:@"%d",(tstr.intValue-1)]];
        }
    }
}


-(void)GC_BadgeSend{
    if (IsGC==1) {
        for (int badx=0;badx<41;badx++) {
            if (BadgeSent[badx]<BadgeEarned[badx]) {
                NSLog(@"Sending Badge %s_%02d",AchieveLabel,badx);
                
                [self.gameCenterManager submitAchievement: [NSString stringWithFormat:@"%s_%02d",AchieveLabel,badx] percentComplete: BadgeEarned[badx] ];
                BadgeSent[badx]=BadgeEarned[badx];
            }
        }
    }
}

-(void)GC_AwardBadge:(int)badge {
    if (BadgeEarned[badge]<100) {
        
    }
    BadgeEarned[badge]=100;
}
-(void)GC_AwardBadge:(int)badge withPerc:(int)perc{
    if (perc<0) {perc=0;}
    if (perc>100) {perc=100;}
    if (BadgeEarned[badge]<perc) {
        
    }
    BadgeEarned[badge]=perc;
}


enum
{
    kCurrentScoreSection= 0,
    kScoreHandlingSection= 1,
    kLeaderBoardSection= 2,
    kShowViewControllersSection= 3
};


#define kNoScoreReusableCellID @"ReusableNoScoreCell"
#define kScoredReusableCellID @"ReusableScoreCell"
#define kDisclosureReusableCellID @"ReusableDisclosureCell"
#define kDisclosureWithLabelReusableCellID @"ReusableDisclosureWithLabelCell"


@synthesize gameCenterManager;

@synthesize gameButtonView;
@synthesize resetAchievementsView;

@synthesize currentScore;
@synthesize cachedHighestScore;

@synthesize personalBestScoreDescription;
@synthesize personalBestScoreString;
@synthesize leaderboardHighScoreDescription;
@synthesize leaderboardHighScoreString;

@synthesize currentLeaderBoard;

- (void) showAlertWithTitle: (NSString*) title message: (NSString*) message
{
    UIAlertView* alert= [[[UIAlertView alloc] initWithTitle: title message: message
												   delegate: NULL cancelButtonTitle: @"OK" otherButtonTitles: NULL] autorelease];
    [alert show];
}




- (IBAction) resetAchievements: (id) sender
{
	[gameCenterManager resetAchievements];
}


- (void) loadPlayerData: (NSArray *) identifiers
{
    [GKPlayer loadPlayersForIdentifiers:identifiers withCompletionHandler:^(NSArray *players, NSError *error) {
        if (error != nil)
        {
            //            NSLog(@"LoadError %@",error);
            // Handle the error.
        }
        if (players != nil)
        {
            for (int n=0;n<6;n++) {
                [Top10Data replaceObjectAtIndex:(BoardRequested*20)+(n*2)+3 withObject:[NSString stringWithFormat:@" "]];
            }
            int n=0;
            for (GKPlayer *player in players) {
                if (n>-1 && n<6) {
                    NSString *tstr=[Top10Data objectAtIndex:(BoardRequested*20)+(n*2)+2];
                    if (tstr.intValue>0) {
                        [Top10Data replaceObjectAtIndex:(BoardRequested*20)+(n*2)+3 withObject:[NSString stringWithFormat:@"%@",player.alias]];
                        //NSLog(@"Putting %@ into %d",player.alias,(BoardRequested*20)+(n*2)+3);
                    }
                }
                n++;
            }
            
        }
    }];
}

- (void) reloadScoresComplete: (GKLeaderboard*) leaderBoard error: (NSError*) error;
{
    if(error == NULL)
    {
        int64_t personalBest= leaderBoard.localPlayerScore.value;
        self.personalBestScoreDescription= @"Your Best:";
        self.personalBestScoreString= [NSString stringWithFormat: @"%ld", personalBest];
        if ([leaderBoard.scores count]>0) {
            
            [Top10Data replaceObjectAtIndex:(BoardRequested*20)+1 withObject:[NSString stringWithFormat:@"4"]];
            for (int n=0;n<6;n++) {
                [Top10Data replaceObjectAtIndex:(BoardRequested*20)+(n*2)+2 withObject:[NSString stringWithFormat:@" "]];
                [Top10Data replaceObjectAtIndex:(BoardRequested*20)+(n*2)+3 withObject:[NSString stringWithFormat:@" "]];
            }
            //NSLog(@"A");
            for (int n=0;n<6;n++) {
                Top10[n+(BoardRequested*10)]=0;
                if ([leaderBoard.scores count]>n) {
                    GKScore* thisscore= [leaderBoard.scores objectAtIndex: n];
                    
                    [Top10Data replaceObjectAtIndex:(BoardRequested*20)+(n*2)+2 withObject:[NSString stringWithFormat:@"%d",thisscore.value]];
                    [Top10IDs replaceObjectAtIndex:n withObject:[NSString stringWithFormat:@"%@",thisscore.playerID]];
                    
                }
            }
        }
        [self loadPlayerData:Top10IDs];
    }
    else
    {
        // Errorsorz
    }
}





// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Standard stuff
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Standard Stuff


int rnd(int max) {return arc4random()%(max+1);}
int rnd_minmax(int min,int max) {return (arc4random()%((max-min)+1))+min;}

float rndf(int max) {return arc4random()%(max+1);}
float rndf_minmax(int min,int max) {return (arc4random()%((max-min)+1))+min;}


int MouseIn(float x,float y,float w,float h) {
    int fout=0;
    w--;h--;
    for (int n=1;n<11;n++) {
        if (mx[n]>x && mx[n]<x+w && my[n]>y && my[n]<y+h && md[n]==1) {fout=n;}
    }
    return fout;
}
int MouseIn_Centered(float x,float y,float w,float h) {
    int fout=0;
    w--;h--;
    x=x-w/2;y=y-h/2;
    for (int n=1;n<11;n++) {
        if (mx[n]>x && mx[n]<x+w && my[n]>y && my[n]<y+h && md[n]==1) {fout=n;}
    }
    return fout;
}


float dsin(float fn) {return sin(fn*0.0174532925);}
float dcos(float fn) {return cos(fn*0.0174532925);}



void SetTo(int SetThis,int SetTo) {
    if (SetThis>-1 && SetThis<15) {
        Set[SetThis]=SetTo;
        NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
        [standardUserDefaults setInteger:Set[SetThis] forKey:[NSString stringWithFormat:@"Settings%d",SetThis]];
        [standardUserDefaults synchronize];
    }
}


void SaveString(NSString *Ident,NSString *Value) {
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    [standardUserDefaults setObject:Value forKey:Ident];
    [standardUserDefaults synchronize];
}
NSString*LoadString(NSString *Ident) {
    NSString *tempstr=[[NSUserDefaults standardUserDefaults] stringForKey:Ident];
    return tempstr;
}

void SaveInt(NSString *Ident,int Value) {
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    [standardUserDefaults setInteger:Value forKey:Ident];
    [standardUserDefaults synchronize];
}
int LoadInt(NSString *Ident) {
    int tempint=[[NSUserDefaults standardUserDefaults] integerForKey:Ident];
    return tempint;
}

void SaveScoreGrid(int Group) {
    int g=Group*20;
    NSString *tempstr=[NSString stringWithFormat:@"%d|%d|%d|%d|%d|%d|%d|%d|%d|%d",High[g+9],High[g+8],High[g+7],High[g+6],High[g+5],High[g+4],High[g+3],High[g+2],High[g+1],High[g+0]];
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    [standardUserDefaults setObject:tempstr forKey:[NSString stringWithFormat:@"Highscore_%d",Group]];
    [standardUserDefaults synchronize];
    
    NSLog(@"Save : %d : %@",Group,tempstr);
    // Add checksum
    
    //////
    int check=0;
    for (int n=0;n<10;n++) {
        check=check+High[g+n]*(ChecksumC+Group);
        check=check%(ChecksumB+Group);
    }
    check=(check*ChecksumD)%ChecksumA;
    for (int n=0;n<10;n++) {
        check=check+High[g+n]+(ChecksumA+Group);
        check=check%(ChecksumC+Group);
    }
    check=check%ChecksumD;
    //////
    
    
    [standardUserDefaults setInteger:check forKey:[NSString stringWithFormat:@"Checksum_%d",Group]];
    [standardUserDefaults synchronize];
    
    
}
void LoadScoreGrid(int Group) {
    int g=20*Group;
    NSString *tempstr=[[NSUserDefaults standardUserDefaults] stringForKey:[NSString stringWithFormat:@"Highscore_%d",Group]];
    NSArray *temparray = [tempstr componentsSeparatedByString:@"|"];
    NSEnumerator *tempenum = [temparray objectEnumerator];  //  Yeah, seriously, ffs..
    
    NSLog(@"Load : %d : %@",Group,tempstr);
    
    id object;
    int max=10;
    while ((object = [tempenum nextObject])) {
        max--;
        if (max>-1) {High[g+max]=[object intValue];}
    }
    
    int Realcheck=[[NSUserDefaults standardUserDefaults] integerForKey:[NSString stringWithFormat:@"Checksum_%d",Group]];
    
    //////
    int check=0;
    for (int n=0;n<10;n++) {
        check=check+High[g+n]*(ChecksumC+Group);
        check=check%(ChecksumB+Group);
    }
    check=(check*ChecksumD)%ChecksumA;
    for (int n=0;n<10;n++) {
        check=check+High[g+n]+(ChecksumA+Group);
        check=check%(ChecksumC+Group);
    }
    check=check%ChecksumD;
    //////
    
    
    if (check!=Realcheck) {
        NSLog(@"Erorchex");
        for (int n=0;n<10;n++) {
            High[g+n]=0;
        }
        SaveScoreGrid(Group);
    }
}


// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Handy Stuff
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#pragma mark -
#pragma mark Handy Stuff

void Goto_URL(NSString *URL) {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:URL]];
    
}
void Goto_iTunes_App(int AppID) {
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://itunes.apple.com/app/id%d?mt=8",AppID]]];
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Drawing
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#pragma mark -
#pragma mark Drawing/Image Stuff

void LoadImage(NSString *filename, int imagenum, int fx,int fy,int flags)  {
    if (imagenum>-1 && imagenum<MostImages) {
        [CCTexture2D setDefaultAlphaPixelFormat:kCCTexture2DPixelFormat_RGBA8888];
        if (flags==NoAlpha) {[CCTexture2D setDefaultAlphaPixelFormat:kCCTexture2DPixelFormat_RGB565];}
        if (flags==OnlyAlpha) {[CCTexture2D setDefaultAlphaPixelFormat:kCCTexture2DPixelFormat_A8];}
        if (flags==LowRGB) {[CCTexture2D setDefaultAlphaPixelFormat:kCCTexture2DPixelFormat_RGBA4444];}
        
        CCTexture2D *texture=[[CCTextureCache sharedTextureCache] addImage:filename];
        [imgs replaceObjectAtIndex:imagenum withObject:texture];
        
        
        imgx[imagenum]=fx;
        imgy[imagenum]=fy;
        imgw[imagenum]=(texture.contentSizeInPixels.width/CC_CONTENT_SCALE_FACTOR())/fx;
        imgh[imagenum]=(texture.contentSizeInPixels.height/CC_CONTENT_SCALE_FACTOR())/fy;
    }
}




void SetBatch(int batchnum,int imagenum,int zorder) {
    if (batchnum>-1 && batchnum<MostBatches) {
        ChangeBatch=1;
        ChangeBatchTo[batchnum]=imagenum;
        ChangeBatchZ[batchnum]=zorder;
    }
}

void MakeArrays(){
    CCTexture2D *texture=[[CCTextureCache sharedTextureCache] addImage:@"Icon.png"];
    for (int n=0;n<MostImages;n++) {
        [imgs addObject:texture];
        imgx[n]=1;imgy[n]=1;
        imgw[n]=8;imgh[n]=8;
    }
    for (int n=0;n<MostBatches;n++) {SetBatch(0,0,0);}
}

-(void)ChangeBatches {
    
    for (int n=0;n<MostBatches;n++) {
        if (BatchIs[n]>-1) {
            CCSpriteBatchNode* QuickBatchb=(CCSpriteBatchNode*) [objBatch objectAtIndex:n*(MaxBatch+1)];
            [self removeChild:QuickBatchb cleanup:YES];
        }
    }
    [objBatch removeAllObjects];
    
    for (int n=0;n<MostBatches;n++) {
        BatchIs[n]=ChangeBatchTo[n];
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:ChangeBatchTo[n]];
        // Batch
        CCSpriteBatchNode* QuickBatch = [CCSpriteBatchNode batchNodeWithTexture:txture];
        [objBatch addObject:QuickBatch];
        
        for (int zee=0;zee<MaxBatch;zee++) {
            CCSprite *sprite = [CCSprite spriteWithTexture:txture rect:CGRectMake(0,0,imgw[ChangeBatchTo[n]],imgh[ChangeBatchTo[n]])];
            [sprite.texture setAliasTexParameters];
            sprite.color=ccc3(255,255,255);
            sprite.scale=scaleTo;
            sprite.position = ccp(-512,-512);
            [QuickBatch addChild:sprite];
            [objBatch addObject:sprite];
        }
        [self addChild:QuickBatch];
        [self reorderChild:QuickBatch z:ChangeBatchZ[n]];
    }
    ChangeBatch=-1;
}


void SetAlpha(int fa) {if (fa<0) {fa=0;} if (fa>255) {fa=255;} J_Alpha=fa;}
void SetBlend(int fa) {
    switch (fa){
        case 1:  J_BlendA=GL_ONE;J_BlendB=GL_ONE_MINUS_SRC_ALPHA; break;
        case 2:  J_BlendA=GL_ZERO;J_BlendB=GL_ONE_MINUS_SRC_ALPHA; break;
        case 3:  J_BlendA=GL_DST_COLOR;J_BlendB=GL_ONE_MINUS_SRC_ALPHA; break;
        case 4:  J_BlendA=GL_DST_COLOR;J_BlendB=GL_ONE; break;
            
        default: J_BlendA=GL_ONE;J_BlendB=GL_ONE_MINUS_SRC_ALPHA; break;
    }
}

void SetCol(int fr,int fg,int fb) {
    if (fr<0) {fr=0;} if (fr>255) {fr=255;} J_Col_R=fr;
    if (fg<0) {fg=0;} if (fg>255) {fg=255;} J_Col_G=fg;
    if (fb<0) {fb=0;} if (fb>255) {fb=255;} J_Col_B=fb;
}

void SetRot(float fa) {J_Rot=fa;}
void SetSize(float fx) {J_ScaleX=fx;J_ScaleY=fx;}
void SetSizeXY(float fx, float fy) {J_ScaleX=fx;J_ScaleY=fy;}


void DrawBatch(int batch,float fx,float fy,int frame) {
    int fi=BatchIs[batch];
    
    if (batch>-1 && batch<MostBatches) {
        if (TopBatch[batch]>-1 && TopBatch[batch]<MaxBatch) {
            fy=jscrh2-(fy*scaleTo);
            int sx=0,sy=0;
            if (frame>0 && frame<imgx[fi]*imgy[fi]) {
                sx=(frame % imgx[fi])*imgw[fi];
                sy=(frame / imgx[fi])*imgh[fi];
            }
            
            CCSprite *gridSprite = (CCSprite *) [objBatch objectAtIndex:((MaxBatch+1)*batch)+1+TopBatch[batch]];
            gridSprite.position = ccp(fx*scaleTo,fy);
            gridSprite.color=ccc3(J_Col_R*PauseDark,J_Col_G*PauseDark,J_Col_B*PauseDark);
            gridSprite.opacity=J_Alpha;
            gridSprite.rotation=J_Rot;
            gridSprite.scaleX=J_ScaleX*scaleTo;
            gridSprite.scaleY=J_ScaleY*scaleTo;
            [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
            TopBatch[batch]++;
        }
    }
}


void DrawImg(int fi,float fx,float fy,int frame) {
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        [gridSprite.texture setAliasTexParameters];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.blendFunc=(ccBlendFunc) { GL_ONE,GL_ONE_MINUS_SRC_ALPHA };
        
        gridSprite.color=ccc3(J_Col_R*PauseDark,J_Col_G*PauseDark,J_Col_B*PauseDark);
        gridSprite.opacity=J_Alpha;
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopSprite++;
    }
}

void DrawImgGlow(int fi,float fx,float fy,int frame) {
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        [gridSprite.texture setAliasTexParameters];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.blendFunc=(ccBlendFunc) { GL_ONE, GL_ONE };
        
        gridSprite.color=ccc3(J_Col_R*PauseDark,J_Col_G*PauseDark,J_Col_B*PauseDark);
        gridSprite.opacity=J_Alpha;
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopSprite++;
    }
}


void DrawImgTile(int fi,float fx,float fy,float fw,float fh) {
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        
        ccTexParams params = {GL_NEAREST, GL_NEAREST, GL_REPEAT, GL_REPEAT};
        [gridSprite.texture setTexParameters: &params];
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R*PauseDark,J_Col_G*PauseDark,J_Col_B*PauseDark);
        gridSprite.opacity=J_Alpha;
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(0,0,fw,fh)];
        TopSprite++;
    }
}



int Clickable(int fi,float fx,float fy,int frame) {
    int inside=-1;
    float tfy=fy;
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        int uw=(imgw[fi]/2)*J_ScaleX;
        int uh=(imgh[fi]/2)*J_ScaleY;
        
        inside=MouseIn(fx-uw,tfy-uh,uw*2,uh*2);
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        [gridSprite.texture setAliasTexParameters];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R,J_Col_G,J_Col_B);
        gridSprite.opacity=J_Alpha;
        if (inside>0) {gridSprite.opacity=J_Alpha;}
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopSprite++;
    }
    return inside;
}



int ClickableHigh(int fi,float fx,float fy,int frame) {
    int inside=-1;
    float tfy=fy;
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        int uw=(imgw[fi]/2)*J_ScaleX;
        int uh=(imgh[fi]/2)*J_ScaleY;
        
        inside=MouseIn(fx-uw,tfy-uh*3,uw*2,uh*5);
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        [gridSprite.texture setAntiAliasTexParameters];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R,J_Col_G,J_Col_B);
        gridSprite.opacity=J_Alpha;
        if (inside>0) {gridSprite.opacity=J_Alpha;}
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopSprite++;
    }
    return inside;
}

int ClickableIs(int fi,float fx,float fy,int frame,int fenabled) {
    int inside=-1;
    float tfy=fy;
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        int uw=(imgw[fi]/2)*J_ScaleX;
        int uh=(imgh[fi]/2)*J_ScaleY;
        
        if (fenabled) {inside=MouseIn(fx-uw,tfy-uh,uw*2,uh*2);}
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        [gridSprite.texture setAntiAliasTexParameters];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R,J_Col_G,J_Col_B);
        gridSprite.opacity=J_Alpha;
        if (inside>0) {gridSprite.opacity=J_Alpha;}
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopSprite++;
    }
    return inside;
}



int Clickablebigger(int fi,float fx,float fy,int frame) {
    int inside=-1;
    float tfy=fy;
    if (TopSprite>-1 && TopSprite<MaxSprites && fi>-1 && fi<MostImages) {
        fy=jscrh2-(fy*scaleTo);
        int sx=0,sy=0;
        if (frame>0 && frame<imgx[fi]*imgy[fi]) {
            sx=(frame % imgx[fi])*imgw[fi];
            sy=(frame / imgx[fi])*imgh[fi];
        }
        int uw=(imgw[fi]/2)*J_ScaleX;
        int uh=(imgh[fi]/2)*J_ScaleY;
        
        inside=MouseIn(fx-uw*1.3,tfy-uh*1.3,uw*2.6,uh*2.6);
        
        CCTexture2D *txture= (CCTexture2D *) [imgs objectAtIndex:fi];
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:TopSprite];
        gridSprite.texture=txture;
        [gridSprite setAnchorPoint: ccp(0.5f,0.5f)];
        [gridSprite.texture setAntiAliasTexParameters];
        gridSprite.position = ccp(fx*scaleTo,fy);
        gridSprite.color=ccc3(J_Col_R,J_Col_G,J_Col_B);
        gridSprite.opacity=J_Alpha;
        if (inside>0) {gridSprite.opacity=J_Alpha;}
        gridSprite.rotation=J_Rot;
        gridSprite.scaleX=J_ScaleX*scaleTo;
        gridSprite.scaleY=J_ScaleY*scaleTo;
        [gridSprite setTextureRect:CGRectMake(sx,sy,imgw[fi],imgh[fi])];
        TopSprite++;
    }
    return inside;
}


void Text2(float fx, float fy,NSString *ftxt,float mid) {
    mid=mid/2;
    
    fy=jscrh2-(fy*scaleTo);
    CCLabelTTF *labelb = (CCLabelTTF *) [fonts objectAtIndex:MaxText];
    //NSLog(@"%@",[fonts objectAtIndex:MaxText]);
    [labelb setAnchorPoint: ccp(mid,1-mid)];
    labelb.position = ccp(fx*scaleTo,fy);
    labelb.color=ccc3(J_Col_R,J_Col_G,J_Col_B);
    labelb.opacity=255;
    //labelb.rotation=J_Rot;
    //labelb.scaleX=J_ScaleX*scaleTo;
    //labelb.scaleY=J_ScaleY*scaleTo;
    if (labelb.string!=ftxt) {[labelb setString:ftxt];}
}


void Text(float fx, float fy,NSString *ftxt,float mid) {
    mid=mid/2;
    if (TopText>-1 && TopText<MaxText) {
        fy=jscrh2-(fy*scaleTo);
        CCLabelAtlas *labelb = (CCLabelAtlas *) [fonts objectAtIndex:TopText];
        [labelb setAnchorPoint: ccp(mid,1-mid)];
        labelb.position = ccp(fx*scaleTo,fy);
        labelb.color=ccc3(J_Col_R,J_Col_G,J_Col_B);
        labelb.opacity=J_Alpha;
        labelb.rotation=J_Rot;
        labelb.scaleX=J_ScaleX*scaleTo;
        labelb.scaleY=J_ScaleY*scaleTo;
        [labelb setString:ftxt];
        [labelb.texture setAntiAliasTexParameters];
        TopText++;
    }
}

void ResetDraw(){
    //-(void) ResetDraw {
    J_ScaleX=1;J_ScaleY=1;J_Rot=0;
    J_Alpha=255;J_Col_R=255;J_Col_B=255;J_Col_G=255;
}


-(void) Flip {
    for (int zee=TopSprite;zee<LastSprite;zee++) {
        CCSprite *gridSprite = (CCSprite *) [objs objectAtIndex:zee];
        gridSprite.position = ccp(-512,-512);
        [gridSprite setTextureRect:CGRectMake(0,0,1,1)];
    }
    LastSprite=TopSprite;
    TopSprite=0;
    
    for (int n=0;n<MostBatches;n++) {
        for (int zee=TopBatch[n];zee<LastBatch[n];zee++) {
            CCSprite *gridSprite = (CCSprite *) [objBatch objectAtIndex:((MaxBatch+1)*n)+1+zee];
            gridSprite.position = ccp(-512,-512);
            [gridSprite setTextureRect:CGRectMake(0,0,1,1)];
        }
        LastBatch[n]=TopBatch[n];
        TopBatch[n]=0;
    }
    
    
    for (int zee=TopText;zee<MaxText;zee++) {
        CCLabelAtlas *labelb = (CCLabelAtlas *) [fonts objectAtIndex:zee];
        labelb.position = ccp(-512,-512);
        [labelb setString:[NSString stringWithFormat:@"" ]];
    }
    
    LastText=TopText;
    TopText=0;
    ResetDraw();
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  MakeyJayHappyCode  - Audio
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Audio Stuff


//  Top bit..  ---
void PlaySFX(int sfxN,float Pitch,float Volume,float Pan) {
    NSString*sfxName=[NSString stringWithFormat:@"%03d.wav",sfxN];
    //  Top bit..  ---
    
    //  All my sound effects, since about 2010, and probably before that
    //  have had a simple "nnn.wav" filename system,
    //  so I just made the PlaySFX follow that pattern.
    //  If you're going to be naming your sfx's properly, switch the top bit for the bottom!
    
    //  Bottom bit.. ---
    //void PlaySFX(NSString*sfxName,float Pitch,float Volume,float Pan) {
    //  Bottom bit.. ---
    
    if (Set[5]==0) {[[SimpleAudioEngine sharedEngine] playEffect:sfxName pitch:Pitch pan:Pan gain:Volume];}

    
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  My Functions
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark My Functions

// Bogstandard shitty starfield effect.
void GenericParticles(int DrawtoBatch) {
    SetSize(1);
    for (int n=0;n<MaxBatch;n++) {
        int ID=n*10;
        if (Part[ID+0]>0) {
            Part[ID+0]=Part[ID+0]-rnd_minmax(1,4);
            Part[ID+1]=Part[ID+1]+dsin(Part[ID+3])*Part[ID+4];
            Part[ID+2]=Part[ID+2]-dcos(Part[ID+3])*Part[ID+4];
            if (Part[ID+3]<180) {Part[ID+3]=Part[ID+3]+rndf_minmax(0,4);}
            if (Part[ID+3]>180) {Part[ID+3]=Part[ID+3]-rndf_minmax(0,4);}
            SetRot(Part[ID+3]);SetAlpha(Part[ID+0]);
            SetCol(Part[ID+6],Part[ID+7],Part[ID+8]);
            DrawBatch(DrawtoBatch, Part[ID+1],Part[ID+2], Part[ID+5]);
        }
    }
}

void AddPart(float fx,float fy,float fn,float fs,float fr1,float fr2) {
    Partto=(Partto+1) % MaxBatch;
    int ID=Partto*10;
    Part[ID+0]=150;
    Part[ID+1]=fx;
    Part[ID+2]=fy;
    Part[ID+3]=(rnd_minmax(fr1, fr2) + 360) % 360;
    Part[ID+4]=fs;
    Part[ID+5]=fn;
    
    Part[ID+6]=rnd_minmax(1,5)*50;
    Part[ID+7]=rnd_minmax(1,5)*50;
    Part[ID+8]=rnd_minmax(1,5)*50;
}

void GenericBackground() {
    ResetDraw();
    SetCol(menuR,menuG,menuB);
    menuR=menuR-((menuR-menuAimR)/8);
    menuG=menuG-((menuG-menuAimG)/8);
    menuB=menuB-((menuB-menuAimB)/8);
    menuRot=menuRot-((menuRot-menuAimRot)/4);
    
    SetSize(2.5);
    SetRot(menuRot);
    DrawImg(5,jscrw/2,jscrh/2,0);
    SetRot(0);
}


void Flash(int fn,int fx,int fy) {
    scflto=(scflto+1)%10;
    scfl[(scflto*10)]=fn;
    scfl[(scflto*10)+1]=fx;
    scfl[(scflto*10)+2]=fy;
    scfl[(scflto*10)+4]=255;
    
}

// Bogstandard shitty starfield effect.
void GenericStarfield(int DrawtoBatch,int WithAccel) {
    for (int n=0;n<MaxBatch;n++) {
        if (WithAccel==0 && Paused==0) {
            StarX[n]=StarX[n]-StarXS[n];
        }
        if (WithAccel==1 && Paused==0) {
            StarX[n]=StarX[n]-StarXS[n]*(AccelX*12);
            StarY[n]=StarY[n]-StarXS[n]*(AccelY*12);
        }
        
        StarR[n]=StarR[n]+StarXS[n];
        
        if (StarX[n]>jscrw+16) {
            StarY[n]=rnd(jscrh);
            StarX[n]=-16;
        }
        if (StarX[n]<-16) {
            StarY[n]=rnd(jscrh);
            StarX[n]=jscrw+16;
        }
        
        if (StarY[n]>jscrh+16) {
            StarX[n]=rnd(jscrw);
            StarY[n]=-16;
        }
        if (StarY[n]<-16) {
            StarX[n]=rnd(jscrw);
            StarY[n]=jscrh+16;
        }
        
        SetRot(StarR[n]);
        SetCol(StarXS[n]*180,StarXS[n]*140,StarXS[n]*80);
        DrawBatch(DrawtoBatch,StarX[n],StarY[n],0);
    }
    ResetDraw();
}




// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Ingame : A set of constant onscreen elements that should always be there
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Ingame Elements

+(void) PauseNow{ // This happens whenever something else on the iPhone tries to do something.
    // ie, we AutoPause whenever one of those stupid alerts pop up right over the top of the fucking screen, in a really annoying way!
    Paused=25;
}
-(void) PauseMenu{
    int py=(jscrh/2)-((25-abs(Paused))*10);
    ResetDraw();
    DrawImg(48,jscrw/2,py,0);
    
    SetSize(1.5);
    SetCol(255,255,255);
    int pbutton=Clickable(49,jscrw/2,py,3);
    if (pbutton>0 && mudown[pbutton]==0 && Paused==25) {mudown[pbutton]=1;Paused=-26;}
    
    SetCol(255,0,0);
    pbutton=Clickable(49, jscrw/2-95,py-64, 4);
    if (pbutton>0 && mudown[pbutton]==0 && Paused==25) {mudown[pbutton]=1;Paused=0;GameMode=50;}
    
    ResetDraw();
    SetCol(100,255,100); if (Set[5]==1) {SetCol(255,100,100);}
    pbutton=Clickable(49,jscrw/2+95,py-64,1+Set[5]);
    if (pbutton>0 && mudown[pbutton]==0) {mudown[pbutton]=1;SetTo(5,1-Set[5]);}
    
    ResetDraw();
    int a=0;
    for (int n=0;n<10;n++) {
        a=MouseIn_Centered(((jscrw/2)-144)+(n*32),jscrh-48+((25-abs(Paused))*5), 32,32);
        DrawImg(49,((jscrw/2)-144)+(n*32),jscrh-48+((25-abs(Paused))*5),6+(Set[4]>n+4));
        if (a>0) {SetTo(4,n+5);}
    }
    Text(jscrw/2,jscrh-16+((25-abs(Paused))*3),@"Tilt Sensitivity",1);
    
}


-(void) Ingame {
    ResetDraw();
    if (Paused==0) {
        DrawImg(49,16,16,0);
        int pbutton=MouseIn(0,0,32,32);
        if (pbutton>0 && mudown[pbutton]==0 && Paused==0) {mudown[pbutton]=1;Paused=2;}
    }
    
    if (Paused!=0) {
        Paused=Paused+2;if (Paused>25) {Paused=25;}
        PauseDark=1;
        [self PauseMenu];
        
        PauseDark=100-(abs(Paused)*3);
        PauseDark=PauseDark/100;
    }
}



-(void)GameEnded{
    
    // Order highscores.
    // 0-4 = Top 5
    // 4-9 = Last 5 plays
    ThisGame=((GameOpt*10)+GameType)*20;
    
    for (int n=9;n>5;n--) {
        High[ThisGame+n]=High[ThisGame+(n-1)];
    }
    High[ThisGame+5]=Score;
    int GotHigh=5;
    for (int n=4;n>-1;n--) {
        if (Score>High[ThisGame+n]) {GotHigh=n;}
    }
    if (GotHigh<5) {
        for (int n=4;n>GotHigh;n--) {
            High[ThisGame+n]=High[ThisGame+(n-1)];
        }
        High[ThisGame+GotHigh]=Score;
    }
    
    SaveScoreGrid(((GameOpt*10)+GameType));
    
    
    // Save Badges
    char ChalComp[64];
    for (int n=0;n<50;n++) {
        ChalComp[n]='n';
        if (BadgeEarned[n]==100) {ChalComp[n]='J';}
    }
    ChalComp[50]=0;
    NSLog(@"Badges_Saved : %s",ChalComp);
    NSUserDefaults *standardUserDefaults = [NSUserDefaults standardUserDefaults];
    NSString *valueToSave = [NSString stringWithFormat:@"%s",ChalComp];
    [standardUserDefaults setObject:valueToSave forKey:[NSString stringWithFormat:@"Badges"]];
    [standardUserDefaults synchronize];
    
    
    [self GC_ReportScore:High[ThisGame] toBoard:((GameOpt*10)+GameType)];
    [self GC_GetTop10:((GameOpt*10)+GameType)];
    
    [self GC_BadgeSend];
    
    GameMode=0;
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Main Menu
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Main Menu


void GameOver() {
    EndofGame++;
    EndofGame++;
    
    int e=((40-EndofGame)*24);
    if (e<-32) {e=-32;}
    
    ResetDraw();
    
    SetRot(45);
    SetCol(180,0,0);
    SetSize(2.3);
    DrawImg(5,0-e,jscrh*.3,0);
    SetCol(0,0,180);
    DrawImg(5,jscrw+e,jscrh*.7,0);
    ResetDraw();
    
    e=jscrh-(EndofGame*12);
    if (e<jscrh/2) {e=jscrh/2;}
    
    //DrawImg(4,jscrw/2,e,0);
    
    if (EndofGame>60) {GameMode=50;}
}

void GameOverB() {
    if (EndofGame>0) {
        EndofGame--;
        EndofGame--;
        
        int e=((40-EndofGame)*24);
        if (e<-32) {e=-32;}
        
        ResetDraw();
        
        SetRot(45);
        SetCol(180,0,0);
        SetSize(2.3);
        DrawImg(5,0-e,jscrh*.3,0);
        SetCol(0,0,180);
        DrawImg(5,jscrw+e,jscrh*.7,0);
        ResetDraw();
        
        e=(EndofGame*12);
        if (e>jscrh/2) {e=jscrh/2;}
        
        //DrawImg(4,jscrw/2,e,0);
        
    }
}

void StartMenu() {
    
    GameMode=GameMode+1;
    Score=0;Level=1;
    MenuIn=32;
    MenuIn2=0;MenuIn3=0;MenuIn4=0;
    LoadImage(@"bg_grid.png",10,8,8,Plain);
    SetBatch(0,2,2);
    SetBatch(1,2,1);
    SetBatch(2,7,10);
    SetBatch(3,7,8);
    SetBatch(4,2,1);
    SetBatch(5,7,50);
    
}

-(void) MainMenu {
    ang++;
    
    if (MenuIn>0) {MenuIn--;}
    if (MenuPick!=1 && MenuIn2>0) {MenuIn2=MenuIn2-2;}
    if (MenuPick==1 && MenuIn2<32) {MenuIn2=MenuIn2+2;}
    if (MenuPick!=2 && MenuIn3>0) {MenuIn3=MenuIn3-2;}
    if (MenuPick==2 && MenuIn3<32) {MenuIn3=MenuIn3+2;}
    if (MenuPick!=3 && MenuIn4>0) {MenuIn4=MenuIn4-2;}
    if (MenuPick==3 && MenuIn4<32) {MenuIn4=MenuIn4+2;}
    
    
    // Background
    ResetDraw();
    
    SetSize(9);// Back
    DrawImg(4,jscrw/2,jscrh*.3-(MenuIn*10),0);
    
    /*// Scrolly back
     SetAlpha(190);
     mscroll=mscroll-1; if (mscroll<0-(8*64)) {mscroll=mscroll+8*64;}
     DrawImg(4,jscrw/2+mscroll,jscrh*.5-(MenuIn*18),3);
     DrawImg(4,(jscrw/2+mscroll)+(64*8),jscrh*.5-(MenuIn*18),3);
     */
    if (EndofGame>0) {ResetDraw(); GameOverB();SetSize(8);}
    
    // Rainbow
    SetAlpha(190);
    DrawImg(4,jscrw*.45,jscrh*.5+(MenuIn*18),2);
    
    // Foreground
    SetAlpha(255);
    DrawImg(4,jscrw/2,jscrh*.7+(MenuIn*10),1);
    
    
    // Logo
    SetRot(0);
    ResetDraw();
    DrawImg(1,jscrw*.4,72-(MenuIn*16),0);
    
    // MenuIn2 = Info/Credits
    if (MenuIn2>0) {
        ResetDraw();
        SetSizeXY(6,5);
        SetCol(100,100,100);
        int atx=jscrw/2-((32-MenuIn2)*16);
        DrawImg(3,atx,jscrh/2,15);
        
        
        SetSize(2);
        SetCol(255,255,0);
        Text(atx-140,jscrh/2-140,@"Untitled",0);
        
        SetCol(255,125,0);
        SetSize(1.5);
        Text(atx-140,jscrh/2-100,@"Instructions\ndo this\ndo that\ndo the other..",0);
        
        SetSize(1);SetCol(255,255,255);
        int a=Clickable(3,atx,jscrh/2+85,11);
        if (a>0 && mudown[a]==0) {mudown[a]=1;Goto_URL(@"http://bit.ly/AGAW_iOS_Games");}
        
        DrawImg(3,atx-116,jscrh/2+116,13);
        
        a=Clickable(3,atx+116,jscrh/2+116,14);
        if (a>0 && mudown[a]==0) {mudown[a]=1;Goto_URL(@"http://AGameAWeek.com");}
        
        SetCol(0,125,255);
        SetSize(1);
        Text(atx-74,jscrh/2+120,@"Created by Jayenkai\nUses Cocos2D\n",0);
        
        a=MouseIn(atx-160,10 ,320,jscrh/2);
        if (a>0 && mudown[a]==0) {mudown[a]=1;MenuPick=0;}
        
    }
    
    
    
    //  jscrw and jscrh are variables I started using in 2010 for Screen Width and Screen Height.
    //  In my BlitzMax framework, they specify my Virtual Resolution, and are then converted into actual res by the Sprite function.
    //  That kinda happens here, too, but it's not quite as fancy!  Works well enough for iPod->iPad res scaling, though.
    //  Be aware though, that an iPad will have a bigger jscrh than an iPod..  (iPhone = iPod!)
    
    //  Retina will be the same values, so draw as if it's still running without retina..  Apple made it auto-scale, so no need to change anything.
    
    
    // Right Bar.
    
    // Right Bar.
    ResetDraw();
    
    MenuPop=72-(MenuIn*3);
    if (MenuIn2>0) {MenuPop=MenuPop-(MenuIn2*4);}
    int limit=MenuPop;
    
    if (MenuIn3>0) {MenuPop=MenuPop+(MenuIn3*5.5);}
    SetCol(60,60,60);
    SetAlpha(180);
    //SetSize(2);
    SetSize(8);
    DrawImg(3,(jscrw+246)-((MenuPop-34)*2),jscrh/2,15);
    
    ResetDraw();
    GameOpt=0;
    ThisGame=((GameOpt*10)+GameType)*20;
    SetSize(1);
    int g=ThisGame;
    
    SetCol(180,255,180);
    Text(jscrw-((limit-34)*2),4,[ NSString stringWithFormat:@"Online\n%@",[Top10Data objectAtIndex:(g)+2] ],0);
    SetCol(255,255,255);
    int a=Clickable(3,jscrw-((limit-34)*2)+36,62,10);
    if (a>0 && mudown[a]==0 && MenuPick!=2) {mudown[a]=1;PlaySFX(1,1,0.5,0.5);MenuPick=2;[self GC_GetTop10:((GameOpt*10)+GameType)];}
    if (a>0 && mudown[a]==0 && MenuPick==2) {mudown[a]=1;PlaySFX(1,1,0.5,0.5);MenuPick=0;}
    
    SetCol(180,180,255);
    Text(jscrw-((limit-34)*2),100,[ NSString stringWithFormat:@"Top 5\n%d\n%d\n%d\n%d\n%d",High[g],High[g+1],High[g+2],High[g+3],High[g+4] ],0);
    SetCol(255,255,180);
    Text(jscrw-((limit-34)*2),200,[ NSString stringWithFormat:@"Last 5\n%d\n%d\n%d\n%d\n%d",High[g+5],High[g+6],High[g+7],High[g+8],High[g+9] ],0);
    
    // Menu 2 (MenuIn3) : GameCenter
    if (MenuIn3<1) {Text2(jscrw*2,jscrh,@".",0);}
    if (MenuIn3>0) {
        ResetDraw();
        int atx=jscrw-((MenuIn3)*13);
        
        SetSize(1);SetCol(255,255,255);
        if (ListShow==0) {
            SetCol(255,255,180);
            Text2(atx,20,[ NSString stringWithFormat:@"Global\n\n%@\n    %@\n%@\n    %@\n%@\n    %@\n%@\n    %@\n%@\n    %@",
                          [Top10Data objectAtIndex:(g)+2],[Top10Data objectAtIndex:(g)+3],
                          [Top10Data objectAtIndex:(g)+4],[Top10Data objectAtIndex:(g)+5],
                          [Top10Data objectAtIndex:(g)+6],[Top10Data objectAtIndex:(g)+7],
                          [Top10Data objectAtIndex:(g)+8],[Top10Data objectAtIndex:(g)+9],
                          [Top10Data objectAtIndex:(g)+10],[Top10Data objectAtIndex:(g)+11]],0);
        }
        if (ListShow==1) {
            SetCol(180,255,255);
            Text2(atx,20,[ NSString stringWithFormat:@"Friends\n\n%@\n    %@\n%@\n    %@\n%@\n    %@\n%@\n    %@\n%@\n    %@",
                          [Top10Data objectAtIndex:(g+400)+2],[Top10Data objectAtIndex:(g+400)+3],
                          [Top10Data objectAtIndex:(g+400)+4],[Top10Data objectAtIndex:(g+400)+5],
                          [Top10Data objectAtIndex:(g+400)+6],[Top10Data objectAtIndex:(g+400)+7],
                          [Top10Data objectAtIndex:(g+400)+8],[Top10Data objectAtIndex:(g+400)+9],
                          [Top10Data objectAtIndex:(g+400)+10],[Top10Data objectAtIndex:(g+400)+11]],0);
        }
        // Text(atx+216,jscrh*.1,[ NSString stringWithFormat:@"You\n\n%d\n\n%d\n\n%d\n\n%d\n\n%d",123456789,567,89,10,1],0);
        
        SetSize(1);SetCol(255,255,255);
        a=Clickable(3,atx+30,260,8);if (a>0 && mudown[a]==0) {mudown[a]=1;ListShow=0;PlaySFX(1,.5,.4,0);[self GC_GetTop10:((GameOpt*10)+GameType)];}
        a=Clickable(3,atx+30+78,260,9);if (a>0 && mudown[a]==0) {mudown[a]=1;ListShow=1;PlaySFX(1,.5,.4,0);[self GC_GetTop10:((GameOpt*10)+GameType)+20];}
        
        
        SetSize(1);SetCol(255,255,0);
        Text(atx+210,120,@"Achievements",0);
        
        
        SetSize(.5);SetCol(255,255,255);
        int u=0;
        int ux=3;
        int uxb=0;
        for (int y=0;y<3;y++) {
            ux=4; uxb=0; if (y>0) {ux=3;uxb=18;}
            for (int x=0;x<ux;x++) {
                u=y*5+x;
                if (BadgeEarned[(y*4+x)+1]<100) {u=24;}
                DrawBatch(3,x*36+atx+200+uxb,y*36+160,u);
                if (MouseIn_Centered(x*36+atx+200+uxb,y*36+160,30,30)) {
                    SetSize(1);
                    DrawBatch(2,1.5*36+atx+200,48,u);
                    // Do texty bit
                    SetSize(.5);
                }
            }
        }
        
        ResetDraw();
        SetSize(.75);
        a=Clickable(3,-38+(MenuIn3*2),jscrh*.5-48,5);if (a>0 && mudown[a]==0) {mudown[a]=1;GameType=1;PlaySFX(1,1,.5,0);[self GC_GetTop10:((GameOpt*10)+GameType+(ListShow*20))];}
        a=Clickable(3,-38+(MenuIn3*2),jscrh*.5,6);if (a>0 && mudown[a]==0) {mudown[a]=1;GameType=2;PlaySFX(1,1,.5,0);[self GC_GetTop10:((GameOpt*10)+GameType+(ListShow*20))];}
        a=Clickable(3,-38+(MenuIn3*2),jscrh*.5+48,7);if (a>0 && mudown[a]==0) {mudown[a]=1;GameType=3;PlaySFX(1,1,.5,0);[self GC_GetTop10:((GameOpt*10)+GameType+(ListShow*20))];}
        
    }
    // Game Buttons (replicate in GameCenter menu, above)
    ResetDraw();
    a=Clickablebigger(3,jscrw*.2,jscrh*.75+(MenuIn*8)+((MenuIn2+MenuIn3+MenuIn4)*8),5);if (a>0 && mudown[a]==0) {mudown[a]=1;GameType=1;GameMode=10;PlaySFX(1,1,1,0);}
    a=Clickablebigger(3,jscrw*.425,jscrh*.73+(MenuIn*11)+((MenuIn2+MenuIn3+MenuIn4)*11),6);if (a>0 && mudown[a]==0) {mudown[a]=1;GameType=2;GameMode=10;PlaySFX(1,1,1,0);}
    a=Clickablebigger(3,jscrw*.65,jscrh*.75+(MenuIn*14)+((MenuIn2+MenuIn3+MenuIn4)*14),7);if (a>0 && mudown[a]==0) {mudown[a]=1;GameType=3;GameMode=10;PlaySFX(1,1,1,0);}
    
    // Mute Button, top left.
    ResetDraw();
    SetCol(100,255,100); if (Set[5]==1) {SetCol(255,100,100);}
    int pbutton=Clickable(49,16-MenuIn*2,16,1+Set[5]);
    if (pbutton>0 && mudown[pbutton]==0) {mudown[pbutton]=1;SetTo(5,1-Set[5]);}
    
    // Info Button
    SetCol(255,255,255);SetAlpha(150);SetSize(.5);
    pbutton=Clickable(3,17-MenuIn*2,jscrh-17,12);
    if (pbutton>0 && mudown[pbutton]==0 && MenuPick!=1) {mudown[pbutton]=1;MenuPick=1;PlaySFX(1,1,.5,-0.5);}
    if (pbutton>0 && mudown[pbutton]==0 && MenuPick==1) {mudown[pbutton]=1;MenuPick=0;PlaySFX(2,1,.5,-0.5);}
    
    
    
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Game One
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#pragma mark -
#pragma mark Game 1

void StartGame1() {
    EndofGame=0;
    GameMode=GameMode+1;
    Score=0;Level=1;
    
    LoadImage(@"bg_grid.png",10,8,8,Plain);
    SetBatch(0,2,2);
    SetBatch(1,2,1);
    SetBatch(2,2,1);
    SetBatch(3,2,1);
    SetBatch(4,2,1);
    SetBatch(5,2,1);
    ListShow=0;
    
}


-(void) PlayGame1 {
    
    ResetDraw();
    
    ResetDraw();
    GenericStarfield(1,1);  // Draw using Batch 1, and use accelerometer!
    
    ResetDraw();
    SetCol(100,255,100);
    Text(jscrw/2,16,[NSString stringWithFormat:@"%08d",Score],1);
    
    if (mdAll==0) {DrawWith=-1;}
    if (EndofGame>0) {GameOver();}
}


// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  Main Loop / Loader
// ------------------------------------------------------------------------------------------
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#pragma mark -
#pragma mark Main Background Loop / Loader

-(void) perFrame {
    if (Paused==0) {PauseDark=1;}
    if (Loader==0) {
        if (GameMode==0) {StartMenu();}
        if (GameMode==1) {[self MainMenu];Paused=0;}
        
        // Game 1
        if (GameMode==10) {StartGame1();[self Ingame];}
        if (GameMode==11) {[self PlayGame1];[self Ingame];}
        
        if (GameMode==50) {[self GameEnded];}
    }
    
    
    if (Loader>0) {
        
        switch (Loader) {
                
            case 1:
                LoadImage(@"BasicIcons.png",49,3,3,LowRGB);  // These are your pause/mute/etc icons.
                
                LoadImage(@"logo.png",1,1,1,Plain);  // Plain : Will load images as 32 bits per pixel.  crikey!
                break;
                
            case 2:
                LoadImage(@"Paused.png",48,1,1,Plain);  // This is the big Pause background thing.
                
                LoadImage(@"star.png",2,1,1,OnlyAlpha);  // OnlyAlpha : Ignores all colors in sprite, keeps the Alpha.  saves 3/4 memory.
                //  Starfield!
                for (int n=0;n<MaxBatch;n++) {
                    StarX[n]=rnd(jscrw);
                    StarY[n]=rnd(jscrh);
                    StarXS[n]=((float)rnd(5)+2)/5;
                }
                break;
                
                
            case 3:
                LoadImage(@"Buttons.png",3,8,8,Plain);  // LowRGB : Uses 4 bits per pixel instead of 8, keeps all channels.  Saves 1/2 memory!
                break;
            case 4:
                LoadImage(@"menu.png",4,4,1,Plain);
                break;
                
            case 5:
                LoadImage(@"bg_grid.png",5,1,1,Plain);    // NoAlpha : Reduces bits per pixel, and strips Alpha.  About 2/3's, give or take.
                break;
                
            case 6:
                LoadImage(@"bg_grid.png",6,16,16,NoAlpha);       //  Although, it should be noted..  I'm only assuming Cocos2D actually does do that!!!
                SetBatch(1,2,2); // Batch#, Use Image#, ZOrder : 0 = right at the back.  If you want the first image behind it, go 1, etc,etc..
                SetBatch(0,6,1);                            //   500 would always be at the front.. .. unless you can somehow handle >500 sprites!!
                break;
                
            case 7:
                LoadImage(@"Badges.png",7,5,5,Plain);
                break;
                
                
                
            default:
                Loader=-1;
                break;
        }
        NSLog(@"Loader : %d",Loader);
        Loader++;
        
    }
    
    
    // Leave these bits!
    if (ChangeBatch>-1) {[self ChangeBatches];ChangeBatch=-1;}
    mdAll=0;
    for (int n=0;n<15;n++) {if (md[n]==1) {mdAll=1;} if (md[n]==0) {mudown[n]=0;}}
    if (mdAll==0) {mudownAll=0;}
    
    if (Set[4]<5 || Set[4]>15) {SetTo(4,9);}
    
    ResetDraw();
    
    for (int n=0;n<10;n++) {
        if (scfl[n*10+4]>0) {
            scfl[n*10+4]=scfl[n*10+4]-8;
            scfl[n*10+2]=scfl[n*10+2]-1;
            SetAlpha(scfl[n*10+4]);
            Text(scfl[n*10+1],scfl[n*10+2],[NSString stringWithFormat:@"%d",scfl[n*10+0] ],1);
        }
    }
    
    [self Flip];
}




// on "init" you need to initialize your instance
-(id) init
{
    
    AVAudioSession *session = [AVAudioSession sharedInstance];
	
	NSError *err = nil;
	[session setActive: YES error: &err];
	[session setCategory:AVAudioSessionCategoryPlayback error:&err];
	[session setPreferredHardwareSampleRate:44100.00 error:&err];

    
    for (int n=0;n<MostBatches;n++) {
        BatchIs[n]=-1;
        LastBatch[n]=MaxBatch;
    }
    imgs=[[NSMutableArray alloc] init];
    objs=[[NSMutableArray alloc] init];
    objBatch=[[NSMutableArray alloc] init];
    sfx=[[NSMutableArray alloc] init];
    fonts=[[NSMutableArray alloc] init];
    
    Top10Data=[[NSMutableArray alloc] init];
    Top10IDs=[[NSMutableArray alloc] init];
    for (int n=0;n<20;n++) {
        [Top10IDs insertObject:[NSString stringWithFormat:@" "] atIndex:n];
    }
    for (int mode=0;mode<32;mode++) {
        for (int n=0;n<20;n++) {
            [Top10Data insertObject:[NSString stringWithFormat:@" "] atIndex:n+(mode*20)];
        }
    }
    
    GameMode=0;
    for (int n=0;n<15;n++) {
		Set[n]=[[NSUserDefaults standardUserDefaults] integerForKey:[NSString stringWithFormat:@"Settings%d",n]];
		Set[n+15]=-1;
	}
    
    SetBlend(1);
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super" return value
	if( (self=[super init] )) {

        CGSize size = [[CCDirector sharedDirector] winSize];
        isPad=0;
        scaleTo=1;ScaleUp=1;
        if (size.width==1024 && size.height==768) {isPad=1;scaleTo=2;ScaleUp=1.066666666666667;}
        if (size.height==1024 && size.width==768) {isPad=1;scaleTo=2;ScaleUp=1.066666666666667;}
        
        // scaleTo
        // This is used internally.  All drawing gets scaled by this value.
        // Basically, if you play on an iPad, everything's 2* bigger.
        // If you'd rather it didn't, make it 1!
        
        // ScaleUp
        // Since the 2*Bigger scale doesn't quite fit the whole of an iPad's screen,
        // you can use ScaleUp to multiply your tiles/grids to fill the whole of the iPad's screen.
        //  Quirky, but works.. kinda..
        // Just don't forget to test it, and scale your graphics up to fit.
        //  Probably best just to overscan things, though.  That works better!
        
        jscrw=size.width/scaleTo;
        jscrh=size.height/scaleTo;
        jscrh2=size.height;
        
        for (int n=0;n<100;n++) {BadgeEarned[n]=0;BadgeSent[n]=0;}

        // Load Fonts
        for (int zee=0;zee<MaxText;zee++) {
            CCLabelAtlas *labelb = [CCLabelAtlas labelWithString:@" " charMapFile:@"HomespunTTBRK_(10x12).png" itemWidth:10 itemHeight:12 startCharMap:32];
            [labelb setAnchorPoint: ccp(0.5f, 0.5f)];
            labelb.position = ccp(-512,-512);
            labelb.color=ccc3(255,255,255);
            [self addChild:labelb];
            [self reorderChild:labelb z:500];
            [fonts addObject:labelb];
        }
        float floatsize=12.0f;
        if (size.width>500) {floatsize=24.0f;}//馬、なし脚を見て！
        CCLabelTTF *label = [CCLabelTTF labelWithString:@"!?馬"
                                             dimensions:CGSizeMake(jscrw,jscrh) alignment:UITextAlignmentLeft
                                               fontName:@"Helvetica" fontSize:floatsize];
        //CCLabelAtlas *label = [CCLabelAtlas labelAtlasWithString:@" " charMapFile:@"HomespunTTBRK_(10x12).png" itemWidth:10 itemHeight:12 startCharMap:32];
        label.position = ccp(-800,-800);
        label.color=ccc3(255,255,255);
        [self addChild:label];
        [self reorderChild:label z:500];
        [fonts addObject:label];
        
        
        
        MakeArrays();
        [self ChangeBatches];
        
        CCTexture2D *texture= (CCTexture2D *) [imgs objectAtIndex:0];
        // Sprites
        for (int zee=0;zee<MaxSprites;zee++) {
            CCSprite *sprite = [CCSprite spriteWithTexture:texture rect:CGRectMake(0,0,MaxSize,MaxSize)];
            sprite.color=ccc3(255,255,255);
            sprite.scale=scaleTo;
            sprite.position = ccp(-512,-512);
            [self addChild:sprite];
            [self reorderChild:sprite z:zee+1];
            [objs addObject:sprite];
        }
        
        
        
        Loader=1;
        //[[CDAudioManager sharedManager] setResignBehavior: kAMRBStop  autoHandle:YES];
        //[[SimpleAudioEngine sharedEngine] playEffect:@"sfx_003.caf"];
	}
    GameType=1;
    OrientationUse=3; // You want to define this at the start, otherwise if the player starts whilst the device is flat, it goes a bit odd!
    
    
    menuAimR=0;menuAimG=0;menuAimB=0;
    self.isTouchEnabled = YES;
	self.isAccelerometerEnabled = YES;
	[[UIAccelerometer sharedAccelerometer] setUpdateInterval:(1.0 / 30)];
    
    //[[UIApplication sharedApplication] setIdleTimerDisabled:YES];
    // ^^ Disable Idle Timer
    
    NSString *savedValue = [[NSUserDefaults standardUserDefaults] stringForKey:@"Badges"];
	if (savedValue) {
        char *savedValuec = [savedValue UTF8String];
        
        if (strlen(savedValuec)==50){
            NSLog(@"Badges : %s",savedValuec);
            for (int n=0;n<50;n++) {
                BadgeEarned[n]=0;
                if (savedValuec[n]=='J') {BadgeEarned[n]=100;}
            }
        }
	}
    
    
    for (int n=0;n<10;n++) {
        LoadScoreGrid(((0)+n));
    }
    
    
    GameType=1;
    
	[self schedule:@selector(perFrame) interval:(1.0f / 45.0f)];
    
    MenuPop=0;
    MenuSelect=0;
    
    
    IsGC=0;
/*
    if (GCAllow==1) {
        if([GameCenterManager isGameCenterAvailable])
        {
            self.gameCenterManager= [[[GameCenterManager alloc] init] autorelease];
            [self.gameCenterManager setDelegate: self];
            [self.gameCenterManager authenticateLocalUser];
            IsGC=1;
            //[gameCenterManager resetAchievements];
            //		[self updateCurrentScore];
        }
        else
        {
            IsGC=0;
            //	[self showAlertWithTitle: @"Game Center Support Required!"
            //					 message: @"The current device does not support Game Center, which this sample requires."];
        }
    }
    */
    
    
    
    
    
    // GameConfig
    modes[0]=3;
    
    modes[1]=3;
    strcpy(modeName[10],"Blank");
    strcpy(modeName[11],"Easy");
    strcpy(modeName[12],"Normal");
    strcpy(modeName[13],"Hard");
    
	return self;
}


// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
	// in case you have something to dealloc, do it in this method
	// in this particular example nothing needs to be released.
	// cocos2d will automatically release all the children (Label)
	
	// don't forget to call "super dealloc"
	[super dealloc];
}

#pragma mark GameKit delegate

-(void) achievementViewControllerDidFinish:(GKAchievementViewController *)viewController
{
	AppController *app = (AppController*) [[UIApplication sharedApplication] delegate];
	[[app navController] dismissModalViewControllerAnimated:YES];
}

-(void) leaderboardViewControllerDidFinish:(GKLeaderboardViewController *)viewController
{
	AppController *app = (AppController*) [[UIApplication sharedApplication] delegate];
	[[app navController] dismissModalViewControllerAnimated:YES];
}
@end
